
from pyTriD import *
from ColorMgmt import ColorMgmt 
from copy import *

class Drawer:

    def __init__(self,units,TriD,mouse):
        self.t = TriD
        self.units = units
        self.mouse = mouse
        

#    def DrawBlocks(self):
#        
#         for block in self.blocks.blocks.values():
#            self.DrawBlock(block)
#    
    
    def drawUnits(self):
        
        # run through the keys of our stuff 
        # data structure
        for id in self.units.keys():
            unit  = self.units[id]
            glPushMatrix()
            glTranslatef(unit.x,unit.y,0)
            glRotatef(unit.r+90,0,0,1)
            unit.Draw()
            glPopMatrix()
    
    
    def drawSelectionForUnits(self,selectedList):
        
        # now go through the selected objects
        # and draw rectangie around them
        for id in selectedList:
                
               try:
                unit = self.units[id] 
                
                glPushMatrix()
                glTranslatef(unit.x,unit.y,0)
                ColorMgmt.BindTexture("sel")
                DrawBox([-0.7,-0.7,0.7,0.7])
                
                h = unit.h/100.
                ColorMgmt.BindTexture("life")
                DrawBox([-0.7,-0.8,1.4*h - .7,-0.7])
                
                glPopMatrix()
               except KeyError:
                pass 
    
    def drawNamedUnits(self):
        
        
       
        # run through the keys of our stuff 
        # data structure
        for id in self.units.keys():
     
            unit = self.units[id]
            glPushMatrix()
            glTranslatef(unit.x,unit.y,0)
            glRotatef(unit.r+90,0,0,1)
            glPushName(id)
            unit.Draw()
            glPopName()
            glPopMatrix()
    
#    
#    def DrawBlock(self,block):    
#        self.Draw(block.units)
#        
#        
#    def Draw(self,units):
#                
#       
#        # make list of object names that we will draw
#        # this way if we modify stuff 
#        # all will be ok
#        keys = units.keys()
#        
#        # run through the keys of our stuff 
#        # data structure
#        for i in keys:
#            o  = units[i]
#            glPushMatrix()
#            glTranslatef(o.x,o.y,0)
#            glRotatef(o.r+90,0,0,1)
#            o.Draw()
#            glPopMatrix()
#
#
#     
#    def SelDrawBlocks(self,selobj):
#        
#         for block in self.blocks.blocks.values():
#            self.SelDrawBlock(block,selobj)
#   
#    def SelDrawBlock(self,block,selobj):    
#        self.SelDraw(block.units,selobj)
#
#    def SelDraw(self,units,selobj):
#        
#        # now go through the selected objects
#        # and draw rectangie around them
#        for o in units.values():
#            if o.id in selobj: 
#                glPushMatrix()
#                glTranslatef(o.x,o.y,0)
#                ColorMgmt.BindTexture("sel")
#                DrawBox([-1.1,-1.1,1.1,1.1])
#                glPopMatrix()
#        
#    def selDrawBlocks(self,selbox):
# 
##        t = self.t
##        
##        """ this fuction draws the aria of the selected 
##        rectangie espesuly for the selection buffer and
##        the selection command
##        
##        logic:
##            
##        figure out the screen
##        apply the screen
##        draw stuff
##        
##        """ 
##        rec = copy(selbox)
##        rec[2] += rec[0]
##        rec[3] += rec[1]
##        if rec[0]>rec[2]: 
##            a = rec[0]
##            rec[0] = rec[2]
##            rec[2] = a
##        if rec[1]>rec[3]: 
##            a = rec[1]
##            rec[1] = rec[3]
##            rec[3] = a
##        rec[1] = t.rec[3]-rec[1]
##        rec[3] = t.rec[3]-rec[3]
##        
##        
##        glMatrixMode(GL_PROJECTION);
##        glPushMatrix()
##        glLoadIdentity();
##        
##        gluPickMatrix( (rec[0]+rec[2])/2, (rec[1]+rec[3])/2, rec[2]-rec[0], -rec[3]+rec[1], glGetIntegerv(GL_VIEWPORT));
##        gluPerspective(45.0, float(t.rec[2])/float(t.rec[3]), 0.1, 1000.0)
##       
##        glMatrixMode(GL_MODELVIEW);
##        glLoadIdentity()                    # Reset The View 
##                
##                
##        self.mouse.m.UseFast()
##        #glTranslatef( self.px , self.py , -self.pz)
##        
##       
#        
#        
#        for block in self.blocks.blocks.values():
#            self.selDrawBlock(block)
#            
##            
##            
##        glMatrixMode(GL_PROJECTION);
##        glPopMatrix() 
##        glMatrixMode(GL_MODELVIEW);
##            
##                     
##            
#    
#    def selDrawBlock(self,block):    
#        self.selDraw(block.units)
#     
#    def selDraw(self,units):
#        
#        
#        keys = units.keys()
#        for id in keys:
#            unit = units[id]
#            glPushMatrix()
#            glTranslatef(unit.x,unit.y,0)
#            glRotatef(unit.r+90,0,0,1)
#            glPushName(id)
#            unit.Draw()
#            glPopName()
#            glPopMatrix()
#    
#    
    
    def SetUpSelectionBuffer(self,selbox):
        
        t = self.t
  
  
        glPushMatrix()
        
        glClear( GL_DEPTH_BUFFER_BIT)
       
  
        glSelectBuffer(10000)
        glRenderMode ( GL_SELECT )
        glInitNames()
        
        
        rec = copy(selbox)
        rec[2] += rec[0]
        rec[3] += rec[1]
        if rec[0]>rec[2]: 
            a = rec[0]
            rec[0] = rec[2]
            rec[2] = a
        if rec[1]>rec[3]: 
            a = rec[1]
            rec[1] = rec[3]
            rec[3] = a
        rec[1] = t.rec[3]-rec[1]
        rec[3] = t.rec[3]-rec[3]
        
        
        glMatrixMode(GL_PROJECTION);
        glPushMatrix()
        glLoadIdentity();
        
        gluPickMatrix( (rec[0]+rec[2])/2, (rec[1]+rec[3])/2, rec[2]-rec[0], -rec[3]+rec[1], glGetIntegerv(GL_VIEWPORT));
        gluPerspective(45.0, float(t.rec[2])/float(t.rec[3]), 0.1, 1000.0)
       
        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity()                    # Reset The View 
                
                
        self.mouse.m.UseFast()
        #glTranslatef( self.px , self.py , -self.pz)
        
       
    def TaredownSelectionBuffer(self): 
       
           
            
        glMatrixMode(GL_PROJECTION);
        glPopMatrix() 
        glMatrixMode(GL_MODELVIEW);
        glPopMatrix()
       
       
    
    def thrDrawBlocks(self):
         
        
        for x in range(-100,100,10):
            for y in range(-100,100,10):
        
             
             glPushName( (x+100)* 1000 + (y+100)   )
             
             
             glBegin(GL_QUADS)                   # Start drawing a 4 sided polygon
             glVertex3f(x, y,  0)    # Bottom Left Of The Texture and Quad
             glVertex3f(x+10, y,  0)    # Bottom Right Of The Texture and Quad
             glVertex3f(x+10, y+10,  0)    # Top Right Of The Texture and Quad
             glVertex3f(x, y+10, 0 )   # Top Left Of The Texture and Quad
             glEnd()
                 
             glPopName()
#        for block in self.blocks.blocks.values():
#            
#             x = block.x
#             y = block.y
#             glColor3f(0.9, 0.0, 0.0)            # Bluish shade
#             glBegin(GL_QUADS)                   # Start drawing a 4 sided polygon
#             glVertex3f(x   , y    , -1.0)        # Top Left
#             glVertex3f(x+9.9, y    , -1.0)        # Top Right
#             glVertex3f(x+9.9, y+9.9, -1.0)         # Bottom Right
#             glVertex3f(x   , y+9.9, -1.0)         # Bottom Left
#             glEnd()    
        
    def thrDrawTiles(self,bx,by):

        glColor3f(0.6, 0.6, 0.6)            # Bluish shade
                          # Start drawing a 4 sided polygon
         
        
            
        for x in range(bx,bx+10):
            for y in range(by,by+10):
                
                glPushName((x-bx)*1000 + (y-by))
                
         
                
                glBegin(GL_QUADS) 
                glTexCoord2f(0.0, 0.0); glVertex3f(x, y,  0)    # Bottom Left Of The Texture and Quad
                glTexCoord2f(1.0, 0.0); glVertex3f(x+1, y,  0)    # Bottom Right Of The Texture and Quad
                glTexCoord2f(1.0, 1.0); glVertex3f(x+1, y+1,  0)    # Top Right Of The Texture and Quad
                glTexCoord2f(0.0, 1.0); glVertex3f(x, y+1,  0)    # Top Left Of The Texture and Quad
                glEnd() 
                glPopName()
              
    
         
             