#!/usr/bin/python


"""

            Andre Von Houck's 
            PyWeek entry
            
            galacticus:
                
                Glacticus would be a (m)morts set in far future with starships larger
                then starts and made purely of energy. Also game would be in 3d with 
                PyOpenGl, the game play would consist of traditional RTS on a 2d map 
                which is the entire galaxy. It would be fully persistent meaning when
                in that is when player logs out their armies would still be on the map
                for other players to kill or be killed buy. The game play would 
                consist of correct allocation of energy and time into massive 
                starships, base construction and research and skill at fast tactical
                decisions under fire. The basic setting would be to get to the core 
                of the galaxy and keep it as log as possible for core contains most 
                amounts of energy.




"""





# my little 3d lib writtn in 2 days
from pyTriD import *
# my little network lib in coulple of lines
from Network import *

# came spasific modules
from Login import Login 
from Chat import Chat
from Mouse import Mouse
from Selector import Selector
from Drawer import Drawer
from UnitForm import UnitForm
from InfoBar import InfoBar
from OptionBar import OptionBar


import MessageMap
import Timer




try:
    import psyco
    psyco.full()
except:
    pass







class Galacticus :
    
    def __init__(self):
       
       
        window = 1280 ,768
        fullscreen = False
         
    
        self.t = TriD(self.Draw,"Galacticus for the pyweek chalange",window,fullscreen)  
        
        
        self.t.gui = TriGUI(self.t,"data/Vera.ttf")
        
        
        #for dual logging
        #ip = '131.191.83.83'
        #ip = '127.0.0.1'
        ip = GetServerIP()
            
        
        try:
            self.net = NetWork( ('',29998),(ip,29999),MessageMap.Map )
        except Exception:
            self.net = NetWork( ('',29777),(ip,29999),MessageMap.Map )

        self.net.g = self
        self.net.timetosend = 0

        self.sounds = TriSound.Sounds()
        self.sounds.play("data/start.WAV",.8)
        self.login = Login(self.t.gui,self.net)
        self.infoBar = InfoBar(self.net,self.t.gui)
        
        
        
        
        self.chat  = Chat(self.t.gui,self.net,self.sounds)
        self.mouse = Mouse(self.t)
        
        self.net.mouse = self.mouse
        
        #----
        
        self.unitTimer = Timer.Timer(.01)
        self.unitForm = UnitForm()
        self.drawer = Drawer( self.unitForm.units ,self.t,self.mouse)
        self.mouse.d =  self.drawer 
        self.selector = Selector(self.t,self.drawer)
        
        
        self.optionBar = OptionBar(self.selector,self.net,self.t.gui,self.sounds,window[1])
        
        
        self.t.Go()
        
        
        
    def __del__(self):
        
        self.net.send("logout" , True)
        sys.exit()
        
        
    def Draw(self,t):
                       
        # Clear The Screen And The Depth Buffer
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
        glLoadIdentity()                    # Reset The View 
        glColor4f(1,1,1,1)
        t.Empty.Bind()
        
        
        self.mouse.Use()
        self.mouse.m.Use()
    
 
#        
#       
            
        self.unitTimer.doTime()
        
        
        self.unitForm.DoEx(self.sounds)
        self.unitForm.Do(self.unitTimer.sec)
       
       
        self.drawer.drawUnits()
        self.drawer.drawSelectionForUnits(self.selector.selobj)
      
       
        if t.now > self.net.timetosend:
            #print "send",t.now
            x = (int(self.mouse.pos[0])/10)*10
            y = (int(self.mouse.pos[1])/10)*10
            self.net.send("getunits", [x,y])
            self.net.timetosend = t.now + .5
            
 
       

        
        if t.keys[ESCAPE] :
            self.net.send("logout" , True)
            sys.exit()
     
     
        if t.keys['q'] :
            print self.unitForm.units
        
       
        if t.keys['r'] :
            self.login = Login(self.t.gui,self.net)
            self.unitForm.units = {}
            t.keys['r'] = False
        
        if t.keys['c'] :
            t.keys['c'] = False
            if len(self.selector.selobj) > 0 :
                self.net.send( "clone" , self.selector.selobj )
                self.sounds.play( "data/ShipConstructed.wav",.2 )
 
          
         
        self.selector.PreGui()
        # dont forget to draw the gui!
        t.gui.Draw()
       
       
        if self.t.MouseFree and self.t.keys[GLUT_RIGHT_BUTTON]:
            
            self.t.keys[GLUT_RIGHT_BUTTON] = False
            
            if len(self.selector.selobj) > 0 :
                self.mouse.SelectTile()
                self.net.send( "move" , [self.selector.selobj, (self.mouse.pos[0] ,self.mouse.pos[1] )] )
                self.sounds.play( "data/ok2.wav" )
 
                glPushMatrix()
                glTranslatef(*self.mouse.pos)
                DrawStar()
                glPopMatrix()
        
        
        self.selector.Use()
        self.mouse.m.EndUse()   
        
Galacticus()
