

#
from OpenGL.GL import *
from OpenGL.GLUT import *
from OpenGL.GLU import *
import sys
from Image import *




class Texture:
    
    ix = 0 
    iy = 0
    Tx = 0
    
    def __init__(self, FileName ):
    
        # print FileName
        image = open(FileName)
    
        self.ix = image.size[0]
        self.iy = image.size[1]
        image.convert("RGBA")
        image = image.tostring("raw", "RGBX", 0, -1)
        
        self.Tx = glGenTextures(1)
        # Create Texture    
        glBindTexture(GL_TEXTURE_2D, self.Tx )   # 2d texture (x and y size)
    
        glPixelStorei(GL_UNPACK_ALIGNMENT,1)
        #glTexImage2D(GL_TEXTURE_2D, 0, 3, self.ix, self.iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)
        
            # texture 3 (mipmapped scaling)
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR)  # scale linearly when image bigger than texture
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST)  # scale linearly + mipmap when image smalled than texture
        glTexImage2D(GL_TEXTURE_2D, 0, 4, self.ix, self.iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
    
        # 2d texture, 3 colors, width, height, RGB in that order, byte data, and the data.
        gluBuild2DMipmaps(GL_TEXTURE_2D, 4, self.ix, self.iy, GL_RGBA, GL_UNSIGNED_BYTE, image)
        
        self.image = image
        #glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
        #glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
        #glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL)
    

    def Bind(self):
        glBindTexture(GL_TEXTURE_2D,self.Tx)    # Rotate The Pyramid On It's Y Axis
        
    def GetColor( self, x, y):
        
          
        
        x = int(x * self.ix) 
        y = int(y * self.iy)
        
        while x >=  self.ix: 
            x-=self.ix
        while x <  0:
            x+=self.ix
        while y >=  self.iy: 
            y-=self.iy
        while y <  0: 
            y+=self.iy
        
        try:
         r = ord(self.image[(y*self.iy+x)*4+0])
         g = ord(self.image[(y*self.iy+x)*4+1])
         b = ord(self.image[(y*self.iy+x)*4+2])
        except:
         print x,y,"in",self.ix,self.iy  
            
        return [r/255.,g/255.,b/255.]

    def getAverege(self):
        
        c = 0
        r = 0
        g = 0
        b = 0
        
        for x in range(self.ix):
            for y in range(self.iy):
                c += 1
                r += ord(self.image[(y*self.iy+x)*3+0])
                g += ord(self.image[(y*self.iy+x)*3+1])
                b += ord(self.image[(y*self.iy+x)*3+2])
        
    
        r = r/c
        g = g/c
        b = b/c
        
        return [r/255.,g/255.,b/255.]
    

class AlphaTexture(Texture):
    
    
    def __init__(self, FileName ):
    
        # print FileName
        image = open(FileName)
    
        self.ix = image.size[0]
        self.iy = image.size[1]
        image.convert("RGBA")
        image = image.tostring("raw", "RGBA", 0, -1)
        
        self.Tx = glGenTextures(1)
        # Create Texture    
        glBindTexture(GL_TEXTURE_2D, self.Tx )   # 2d texture (x and y size)
    
        glPixelStorei(GL_UNPACK_ALIGNMENT,1)
        #glTexImage2D(GL_TEXTURE_2D, 0, 3, self.ix, self.iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)
        
            # texture 3 (mipmapped scaling)
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR)  # scale linearly when image bigger than texture
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST)  # scale linearly + mipmap when image smalled than texture
        glTexImage2D(GL_TEXTURE_2D, 0, 4, self.ix, self.iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
    
        # 2d texture, 3 colors, width, height, RGB in that order, byte data, and the data.
        gluBuild2DMipmaps(GL_TEXTURE_2D, 4, self.ix, self.iy, GL_RGBA, GL_UNSIGNED_BYTE, image)
        
        
        #glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
        #glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
        #glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND)
    
    
    def Bind(self):
        glEnable( GL_BLEND )
        glDepthMask( GL_FALSE )   
        glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
        glBindTexture(GL_TEXTURE_2D,self.Tx)    
        
    def UnBind(self):
        
        glDepthMask( GL_TRUE )   
        glDisable( GL_BLEND )
  
  
class MultiTexture( Texture ):
    
    ix = 0 
    iy = 0
    Tx = 0
    
    def __init__(self, FileName ):
    
        # print FileName
        image = open(FileName)
    
        self.ix = image.size[0]
        self.iy = image.size[1]
        image = image.tostring("raw", "RGBX", 0, -1)
        
        self.Tx = glGenTextures(1)
        # Create Texture    
        glBindTexture(GL_TEXTURE_2D, self.Tx )   # 2d texture (x and y size)
    
        glPixelStorei(GL_UNPACK_ALIGNMENT,1)
        #glTexImage2D(GL_TEXTURE_2D, 0, 3, self.ix, self.iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)
        
            # texture 3 (mipmapped scaling)
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR)  # scale linearly when image bigger than texture
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST)  # scale linearly + mipmap when image smalled than texture
        glTexImage2D(GL_TEXTURE_2D, 0, 4, self.ix, self.iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
    
        # 2d texture, 3 colors, width, height, RGB in that order, byte data, and the data.
        gluBuild2DMipmaps(GL_TEXTURE_2D, 4, self.ix, self.iy, GL_RGBA, GL_UNSIGNED_BYTE, image)
        
        self.image = image
        #glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
        #glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
        #glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL)
    

    def Bind(self):
        glBindTexture(GL_TEXTURE_2D,self.Tx)    # Rotate The Pyramid On It's Y Axis


class Empty:
    
    def __init__(self):
    
        self.ix = 1 
        self.iy = 1 
        image = "\0FF\0FF\0FF\0FF"
        
        self.Tx = glGenTextures(1)
        # Create Texture    
        glBindTexture(GL_TEXTURE_2D, self.Tx )   # 2d texture (x and y size)
    
        glPixelStorei(GL_UNPACK_ALIGNMENT,1)
        #glTexImage2D(GL_TEXTURE_2D, 0, 3, self.ix, self.iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)
        
            # texture 3 (mipmapped scaling)
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR)  # scale linearly when image bigger than texture
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST)  # scale linearly + mipmap when image smalled than texture
        glTexImage2D(GL_TEXTURE_2D, 0, 4, self.ix, self.iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
    
        
        self.image = image
        #glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
        #glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
        #glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL)
    
    
    
    def Bind(self):
        glBindTexture(GL_TEXTURE_2D,self.Tx)    # Rotate The Pyramid On It's Y Axis
    
      
    
class Material:
  "TriD material"
  def __init__(self, 
               texture = None,
               ambient = [1.0, 1.0, 1.0, 1.0],
               diffuse = [1.0, 1.0, 1.0, 1.0],
               specular = [1.0, 1.0, 1.0, 1.0],
               shininess=1,
               transparency=1):
                   
                   
    self.texture = texture
    
    
    self.doublesided = None # not implemented
    
    self.name = ""
    self.ambient      = ambient
    self.diffuse      = diffuse
    self.specular     = specular
    self.shininess    = shininess
    self.transparency = transparency
    
    
  def Bind(self):
    print "F"  
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, self.ambient)
    glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, self.diffuse)
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, self.specular)
    glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, self.shininess)
    glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, (self.shininess/100.0)*128)
    
    if self.texture: 
        self.texture.Bind()

    
      
  
  