

from OpenGL.GL import *
from Vector import *

from copy import *

class Matrix:
    
    mx = 0
    
    def __init__ (self , mx=None ):
       if mx is None:       
        glPushMatrix()
        glLoadIdentity()                    # Reset The Projection Matrix
        self.mx = glGetDoublev(GL_MODELVIEW_MATRIX)
        glPopMatrix()
       else: 
        self.mx = deepcopy( mx )
        
    def UseFast(self):
        glMultMatrixd( self.mx )
            
 
                
    def EndUse(self):
        glPopMatrix()
   

   
    def Use(self):
        glPushMatrix()
        glMultMatrixd( self.mx )             
        
    def Invert(self):
      
        mx = self.mx
        
        d = mx[0][0]*(mx[1][1]*mx[2][2] - mx[1][2]*mx[2][1]) + mx[0][1]*(mx[1][2]*mx[2][0] - mx[1][0]*mx[2][2]) + mx[0][2]*(mx[1][0]*mx[2][1] - mx[1][1]*mx[2][0])
             
        a = [(mx[1][1]*mx[2][2] - mx[1][2]*mx[2][1])/d,(mx[0][2]*mx[2][1] - mx[0][1]*mx[2][2])/d,(mx[0][1]*mx[1][2] - mx[0][2]*mx[1][1])/d, 0]
        b = [(mx[1][2]*mx[2][0] - mx[1][0]*mx[2][2])/d,(mx[0][0]*mx[2][2] - mx[0][2]*mx[2][0])/d,(mx[0][2]*mx[1][0] - mx[0][0]*mx[1][2])/d, 0]
        c = [(mx[1][0]*mx[2][1] - mx[1][1]*mx[2][0])/d,(mx[0][1]*mx[2][0] - mx[0][0]*mx[2][1])/d,(mx[0][0]*mx[1][1] - mx[0][1]*mx[1][0])/d, 0]
        e = [ - (mx[1][0]*(mx[2][1]*mx[3][2] - mx[2][2]*mx[3][1]) + mx[1][1]*(mx[2][2]*mx[3][0] - mx[2][0]*mx[3][2]) + mx[1][2]*(mx[2][0]*mx[3][1] - mx[2][1]*mx[3][0]))/(mx[0][0]*(mx[1][1]*mx[2][2] - mx[1][2]*mx[2][1]) + mx[0][1]*(mx[1][2]*mx[2][0] - mx[1][0]*mx[2][2]) + mx[0][2]*(mx[1][0]*mx[2][1] - mx[1][1]*mx[2][0])), (mx[0][0]*(mx[2][1]*mx[3][2] - mx[2][2]*mx[3][1]) + mx[0][1]*(mx[2][2]*mx[3][0] - mx[2][0]*mx[3][2]) + mx[0][2]*(mx[2][0]*mx[3][1] - mx[2][1]*mx[3][0]))/(mx[0][0]*(mx[1][1]*mx[2][2] - mx[1][2]*mx[2][1]) + mx[0][1]*(mx[1][2]*mx[2][0] - mx[1][0]*mx[2][2]) + mx[0][2]*(mx[1][0]*mx[2][1] - mx[1][1]*mx[2][0])), - (mx[0][0]*(mx[1][1]*mx[3][2] - mx[1][2]*mx[3][1]) + mx[0][1]*(mx[1][2]*mx[3][0] - mx[1][0]*mx[3][2]) + mx[0][2]*(mx[1][0]*mx[3][1] - mx[1][1]*mx[3][0]))/(mx[0][0]*(mx[1][1]*mx[2][2] - mx[1][2]*mx[2][1]) + mx[0][1]*(mx[1][2]*mx[2][0] - mx[1][0]*mx[2][2]) + mx[0][2]*(mx[1][0]*mx[2][1] - mx[1][1]*mx[2][0])), 1]
               
        mx = [a,b,c,e]
        return Matrix( mx )
#    
    def Pos(self):
        return Vec( self.mx[3] )  #pass 3rd row because that is the position
        
    def Dir(self):
        return self.Into ( self.Pos() )

    def Into(self, v):
        mx = self.mx
        return Vec( [ mx[0][0]*v.x + mx[1][0]*v.y + mx[2][0]*v.z + mx[3][0], mx[0][1]*v.x + mx[1][2]*v.y + mx[2][1]*v.z + mx[3][1], mx[0][2]*v.x + mx[1][3]*v.y + mx[2][2]*v.z + mx[3][2]] )
        
                       
    def Edit(self):
        glPushMatrix()
        glLoadIdentity() 
        #glLoadMatrixd( self.mx )
    def EditFast(self):
        glPushMatrix()
        
        glLoadMatrixd( self.mx )
            
        
    def EndEdit(self):
        self.mx = glGetDoublev(GL_MODELVIEW_MATRIX)
        glPopMatrix()
        
