
from pyTriD import * 
from OpenGL.GL import *
from OpenGL.GLUT import *
from Font import Font
import math

global GUI
global TriD 
global Theme


class CallBackError(Exception): pass



class TriGUI:

    def __init__(self,t,fontname):
        global GUI
        global TriD 
        global Theme
        Theme = White()
        TriD = t
        
        
        t.keyHook = self.OnKey
                
        GUI = self
        
        self.font = Font(fontname,14)
        self.clip = []
        
        self.dragging = None
        self.typeinto = None
        
        
        self.lastmsgp = 0



        self.Desktop = Container("Desktop", [0,0,t.rec[2],t.rec[3]] )
        
        
    def OnKey(self,*args):
               
        char = args[0]    
        if self.typeinto != None:
            self.typeinto.AddChar(char)
            return None
        
        return args
        
        
    def Draw(self):
        
        global TriD
        
        if TriD.rec[2] == 0:
            return
        
        self.setup2D()
        
        self.pushClipping(TriD.rec)
        
        
        if self.dragging != None:
            perent  = [ self.dragging.wrec[0] - self.dragging.rec[0] , self.dragging.wrec[1] - self.dragging.rec[1] ]
            self.dragging.rec[0]=TriD.mouse[0]+self.dragoffset[0]-perent[0]
            self.dragging.rec[1]=TriD.mouse[1]+self.dragoffset[1]-perent[1]
            
        self.Desktop.upDate(TriD)
        
        self.Desktop.draw()
        
        if TriD.MouseFree and TriD.keys[GLUT_LEFT_BUTTON]:
            self.typeinto = None   
        
        
        
        self.teardown2D()
    
        self.popClipping()
        glDisable(GL_SCISSOR_TEST)
         
    
        
    def setup2D(self):
        """Setup everything on the opengl Stack to draw in 2D in a way that can be torn down later.
        """
        global TriD
        
        glMatrixMode(GL_PROJECTION)
        glPushMatrix()
        glLoadIdentity()
        glOrtho( 0, TriD.rec[2], TriD.rec[3], 0, -1, 1 )

        glMatrixMode(GL_MODELVIEW)
        glPushMatrix()
        glLoadIdentity()

        glDepthMask(0)
        glDisable(GL_DEPTH_TEST)
        glEnable(GL_SCISSOR_TEST)

        glEnable(GL_BLEND)
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)

    def teardown2D(self):
        """tear down the 2D stuff to revert to the previous state.
        """
        glPopMatrix()    
        glMatrixMode(GL_PROJECTION)
        glPopMatrix()
        glDepthMask(1)
        glEnable(GL_DEPTH_TEST)
        glDisable(GL_SCISSOR_TEST)
        glMatrixMode(GL_MODELVIEW)
    
    def pushClipping(self, rect = None):
        
        #offsets = glGetIntegerv( GL_MODELVIEW_MATRIX )
        #tx = offsets[3][0]
        #ty = offsets[3][1]
        #rect = [ rect[0]+tx, rect[1]+ty, rect[0]+rect[2]+tx, rect[1]+rect[3]+ty ]        
        try: 
        #print "<",rect
         if len(self.clip) > 0 and rect != None:
            
            rect = [ rect[0], rect[1], rect[0]+rect[2], rect[1]+rect[3] ]        
                   
            oldrect = self.clip[len(self.clip)-1]
        
            # new rect must fit inside this one....
        
            if rect[0] < oldrect[0] :
                rect[0] = oldrect[0]
            if rect[1] < oldrect[1] :
                rect[1] = oldrect[1]
            if rect[2] > oldrect[2] :
                rect[2] = oldrect[2]
            if rect[3] > oldrect[3] :
                rect[3] = oldrect[3]
            
            
            if rect[0] > rect[2] or rect[1] > rect [3]:
                rect = None
            
            #print ":",rect 
        except Exception:
            rect = None    
               
        self.clip.append(rect)
        self.setClipping(rect)
            
            
    def popClipping(self):
            
        #print
        self.clip.pop()
        if len(self.clip)!= 0 : 
            self.setClipping(self.clip[len(self.clip)-1])

    def setClipping(self, rect = None):
        """set the clipping rectangle for the main screen. defaults to clearing the clipping rectangle.
        NOTE: isn't working..."""
        global TriD
        
        if rect == None:
            return

        mx = TriD.mouse[0]
        my = TriD.mouse[1]
        px = mx+100
        py = my+100
       
        mx = rect[0]
        my = rect[1]
        px = rect[2]
        py = rect[3]
        
        
        
        #return
        
        #corrected = (offsets[3][0] + rect[0], TriD.rec[3] - offsets[3][1] - rect[3] - rect[1], rect[2], rect[3])
        #corrected = (rect[0], TriD.rec[3] - rect[3] - rect[1], rect[2], rect[3])
             
        #glScissor(rec[0],rec[1],rec[2]-rec[0],rec[3]-rec[1])
        #glScissor(*corrected)
        glScissor( mx,TriD.rec[3]-py,px-mx,py-my)
        
        #glScissor( mx,TriD.rec[3]-my-100,100,100)
        #glScissor( rect[0],TriD.rec[3]-rect[1]-rect[3],rect[2],rect[3])
       
       
    
    def MsgBox(self,title,text):
        
        p = self.lastmsgp 
        self.lastmsgp += 10
        
        if p > 300:
            self.lastmsgp = 0
        
        size,high = self.font.getTextSize(text)
        size +=10
        msgBox = Frame( title,[p,p,size+40,100] )
        msgBoxText = Label( text, [10,20,size,20] )
        okButton     = Button( "ok", ExitButton , [size-60,50,40,20] )
        okButton.m   = msgBox
        msgBox.Add(msgBoxText)
        msgBox.Add(okButton)
        self.Add(msgBox)
        self.Up(msgBox)
     
     
    def Up(self, child ):
        self.Desktop.Up( child )
     
    
    def Add(self, child):
        self.Desktop.Add( child )
    
        
class White:
    
    def BackBox(self,rec):
        glColor4f(.8,.8,.8,.7)
        glBegin(GL_QUADS)       
        glVertex2f(0,0)
        glVertex2f(rec[2],0)
        glVertex2f(rec[2],rec[3])
        glVertex2f(0,rec[3])
        glEnd() 
   
    def Box(self,rec):
        glColor4f(1,1,1,1)
        glBegin(GL_QUADS)       
        glVertex2f(0,0)
        glVertex2f(rec[2],0)
        glVertex2f(rec[2],rec[3])
        glVertex2f(0,rec[3])
        glEnd()          
    
    
    def SetFontColor():
        glColor4f(0,0,0,1)
    
    def Crusor(self,rec):
        glColor4f(0,0,0,1)
        glBegin(GL_QUADS)       
        glVertex2f(rec[0],rec[1])
        glVertex2f(rec[2]+rec[0],rec[1])
        glVertex2f(rec[2]+rec[0],rec[3]+rec[1])
        glVertex2f(rec[0],rec[3]+rec[1])
        glEnd()          
    



    def SelBox(self,rec):
        glColor4f(0,0,1,.8)
        glBegin(GL_QUADS)       
        glVertex2f(0,0)
        glVertex2f(rec[2],0)
        glVertex2f(rec[2],rec[3])
        glVertex2f(0,rec[3])
        glEnd() 

    def SelBox2(self,rec):
        
        glColor4f(1,1,1,.8)
        glBegin(GL_QUADS)       
        glVertex2f(rec[0],rec[1])
        glVertex2f(rec[0]+rec[2],rec[1])
        glVertex2f(rec[0]+rec[2],rec[1]+rec[3])
        glVertex2f(rec[0],rec[1]+rec[3])
        glEnd() 





class Container:
   
    def __init__(self, name = "someContainer",  rec = [0,0,300,300] ):
        
        global GUI
        
        self.name = name              # tile 
        self.text = name              # the text
        self.font = GUI.font          # font to use  
        self.children = []            # widgets after it
        
        #**
        self.killme = False           # kill next round
         
         
        self.rec = list(rec)                # rectangile in the groop
        self.wrec = rec               # rectangle in the window 
         
        
        if len(self.rec) != 4:
            raise ValueError( "rec muct be a 4 tupple or list" )
        
       
           
        
        
    def draw(self):
        
        global Theme,TriD,GUI
        
              
        glPushMatrix()
        GUI.pushClipping( self.wrec )
        glTranslatef( self.wrec[0],self.wrec[1] ,0  )
        self.Draw()
        glPopMatrix()
        
        for self.child in reversed( self.children ):
            self.child.draw()
    
        GUI.popClipping()
    
    def Draw(self):
        global Theme,TriD,GUI
        
        #TriD.Empty.Bind()
        #Theme.BackBox( self.rec )

    
    def upDate(self,m):
             
        global TriD , GUI
         
        self.wrec = [ self.rec[0] + m.wrec[0] ,
                      self.rec[1] + m.wrec[1] ,
                      self.rec[2] ,
                      self.rec[3] ]
          
        if len(self.children) > 0:
            for child in self.children:
                child.upDate(self)
                if GUI.dragging == child:
                    self.Up(child)
            
            i = 0         
            while i < len(self.children):
               
               if self.children[i].killme:
                   del self.children[i]
               i+=1
      
        self.UpDate(m)
        
    def UpDate(self,m):
        pass    
        
    def Up(self, child ):
        self.children.remove( child )
        self.children.insert( 0, child ) 
    
    def Add(self, child):
        self.children.insert( 0, child )

class Panel(Container):

    def Draw(self):
        global Theme,TriD,GUI
        
        TriD.Empty.Bind()
        Theme.BackBox( self.rec )
        


# widgets dont have children
class Widget:
    
    
    def __init__(self, name = "someWiget",  rec = [0,0,50,10] ):
        
       
        self.name = name              # tile 
        self.text = name              # the text
        self.font = GUI.font          # font to use  
        
        #**
        self.killme = False           # kill next round
         
        self.rec = list(rec)                # rectangile in the groop
        self.wrec = rec               # rectangle in the window 
             
        if len(self.rec) != 4:
            raise ValueError( "rec muct be a 4 tupple or list" )
        
       
       
        
    def draw(self):
        
        global Theme,TriD,GUI
        
        
        glPushMatrix()
        GUI.pushClipping( self.wrec )
        glTranslatef( self.wrec[0],self.wrec[1] ,0  )
        self.Draw()
        glPopMatrix()
        GUI.popClipping()
    
    def Draw(self):
        global Theme,TriD,GUI
        
        TriD.Empty.Bind()
        Theme.BackBox( self.rec )

    
    def upDate(self,m):
             
        global TriD , GUI
        
        self.wrec = [ self.rec[0] + m.wrec[0] ,
                      self.rec[1] + m.wrec[1] ,
                      self.rec[2] ,
                      self.rec[3] ]
        
      
        self.UpDate(m)
        
    def UpDate(self,m):
        pass    
    
    
    
        
class BasicFrame(Container):
    
    def __init__(self, name = "someFrame",  rec = [0,0,300,300] ):
        
        Container.__init__(self,name,rec )
        self.TitleBar = PushButton(name,self.DragMe,self.StopDragMe, [0,0,rec[2],20]) 
               
        self.children.insert( 0, self.TitleBar )
        
        
    def Draw(self):
        
        TriD.Empty.Bind()
        Theme.BackBox( self.rec )        # window
         
    def Kill(self,Button=None):
        self.killme = True
      
    def DragMe(self,button=None):
        
        global GUI ,TriD 
        GUI.dragging = self
        
        #GUI.dragoffset = [ self.wrec[0] - TriD.mouse[0] ,self.wrec[1] - TriD.mouse[1] ]
        
        perent  = [ self.wrec[0] - self.rec[0] , self.wrec[1] - self.rec[1] ]
        
        GUI.dragoffset = [ self.wrec[0] - TriD.mouse[0] ,self.wrec[1] - TriD.mouse[1] ]
        
        
    def StopDragMe(self,button=None):  
    
        global GUI
        GUI.dragging = None
    
    def Add(self, child):
         
        child.rec[1]+=20
        self.children.insert( 0, child )


class Frame( BasicFrame ):
    
    
    def __init__(self, name = "someFrame",  rec = [0,0,300,300] ):
        
        Container.__init__(self,name,rec )
        self.TitleBar = PushButton(name,self.DragMe,self.StopDragMe, [0,0,rec[2],20]) 
        self.Add(self.TitleBar )
        self.X = Button("X",self.Kill, [rec[2]-19,1,18,18]) 
        self.Add( self.X )
        self.Resize = PushButton("",self.StartResize,self.StopResize, [rec[2]-10,rec[3]-10-20,10,10]) 
        self.Add( self.Resize )
       
       
       
            
    def UpDate(self,m):
        
        global GUI
        
        self.rec[2] = self.Resize.rec[0]+10
        self.rec[3] = self.Resize.rec[1]+10
        
        if self.rec[2] < 50 : 
            self.rec[2] = 50
            self.Resize.rec[0] = 40
            GUI.dragging = None
        
        if self.rec[3] < 20 : 
            self.rec[3] = 20
            self.Resize.rec[1] = 10
            GUI.dragging = None
                   
        self.TitleBar.rec =   [0,0,self.rec[2],20]   
        self.X.rec =   [self.rec[2]-19,1,18,18]   
        
          
               
    def StartResize(self,button):
    
         global GUI
         GUI.dragging = button
         GUI.dragoffset = [ button.wrec[0] - TriD.mouse[0] ,button.wrec[1] - TriD.mouse[1] ]
        
        
    def StopResize(self,button):
        
        global GUI
        GUI.dragging = None
    
class Button(Widget):
    
    def __init__(self, name = "someWiget", OnPress = None ,  rec = [0,0,10,50] ):
               
        Widget.__init__(self,name,rec)
        
        self.OnPress = OnPress
        self.over = False
    
    
    def UpDate(self,m):
        
        global TriD , GUI

        if TriD.MouseFree and TriD.MouseInside( self.wrec ):
          
            TriD.MouseFree = False # grab it!
            
            
            if TriD.keys[GLUT_LEFT_BUTTON] and self.over :
             
                try:
                 self.OnPress(self)
                except TypeError,e:
                 raise CallBackError( str(e)+"\n must take a button instance!" )
             
                TriD.keys[GLUT_LEFT_BUTTON] = False
                GUI.typeinto = None
            
            if not TriD.keys[GLUT_LEFT_BUTTON]:
                self.over = True
            
        else:
            self.over = False
            
        
       
        
        
    def Draw(self):
        
        global Theme,TriD,GUI
        
        
        TriD.Empty.Bind()
        Theme.BackBox( self.rec )
              
        if (self.over):
            Theme.Box( self.rec )
            glColor4f(0,0,0,1)
        else:
            Theme.BackBox( self.rec )
            glColor4f(0,0,0,1)
       
        
        glPushMatrix();
        glTranslatef(  3,0 ,0  )
        
        self.font.flatPrint(  self.name ) 
        glPopMatrix()
        
def ExitButton(self):
    self.m.killme = True
    

class PushButton(Button):    
    
    def __init__(self, name = "PushButton", OnPress = None ,OnRelease = None ,  rec = [0,0,10,50] ):
                             
        Button.__init__(self,name, OnPress, rec)
        self.OnRelease = OnRelease
    
    def UpDate(self,m):
        
        global TriD , GUI

        if TriD.MouseFree and TriD.MouseInside( self.wrec ):
          
            TriD.MouseFree = False # grab it!
            
            
            if TriD.keys[GLUT_LEFT_BUTTON]:
                self.over = True
               
                if TriD.keys[GLUT_LEFT_BUTTON] == True:
                    try:
                        self.OnPress(self)
                    except TypeError,e:
                        raise CallBackError( str(e)+"\n must take a button instance!" )
             
                TriD.keys[GLUT_LEFT_BUTTON] = 7
            
                
            elif  self.over == True:
                 try:
                     self.OnRelease(self)
                 except TypeError,e:
                     raise CallBackError( str(e)+"\n must take a button instance!" )
                 
                 self.over = False
                 
        elif  self.over == True:
             try:
                 self.OnRelease(self)
             except TypeError,e:
                 raise CallBackError( str(e)+"\n must take a button instance!" )
             self.over = False
                   
        else:
            self.over = False
        
class Label(Widget):
    
    def Draw(self):
         
        glPushMatrix();
        glTranslatef(  3,0 ,0  )
        glColor(0,0,0,1)
        self.font.flatPrint(  self.name ) 
        glPopMatrix()
        
     
class Icon(Widget):
    
    def __init__(self,file,name = "someIcon",  rec = None):
        
        
        
        Widget.__init__(self,name, rec)
        self.icon = AlphaTexture(file)
        
        
    
    def Draw(self):
        
        rec = self.rec
        self.icon.Bind()
        glPushMatrix();
        glColor3f(1,1,1)
        glBegin(GL_QUADS)       
        glTexCoord2f(0,1);glVertex2f(0,0)
        glTexCoord2f(1,1);glVertex2f(rec[2],0)
        glTexCoord2f(1,0);glVertex2f(rec[2],rec[3])
        glTexCoord2f(0,0);glVertex2f(0,rec[3])
        glEnd()
        glPopMatrix()


    
class IconButton(Button,Icon):
    
    def __init__(self,file,name = "someIcon",OnPress=None,  rec = None):
        
        #print rec
        Button.__init__(self,name,OnPress, rec)
        self.icon = AlphaTexture(file)
    
    def Draw(self):
        Button.Draw(self);
        Icon.Draw(self)
      
        
class Text(Widget):
 
    def __init__(self, name = "someWiget",  rec = (10,10,200,10) ):
        
        
        Widget.__init__(self,name,rec)
        
        self.lock = False
        self.OnEnter = None
        self.crusor = 0    
        self.selcrusor = 0
        
    def UpDate(self,m):
        
        global TriD 

        if TriD.MouseFree and TriD.MouseInside( self.wrec ):
          
            TriD.MouseFree = False # grab it!
            if self.lock :         # if you cant do a thing about it
                return             # just return
                       
            if TriD.keys[GLUT_LEFT_BUTTON]:
                GUI.typeinto = self
                self.onMouse(TriD.mouse)
                if TriD.keys[GLUT_LEFT_BUTTON] == True:
                    self.selcrusor = self.crusor
                TriD.keys[GLUT_LEFT_BUTTON] = 7
                                   
            

        
        
        
        
    def Draw(self):
        
        global Theme,TriD,GUI
        
        
        TriD.Empty.Bind()
        Theme.BackBox( self.rec )
        
        
        
        if GUI.typeinto == self:
            self.DrawCaret()
            #ts = self.font.getTextSize(self.text[:self.crusor])
            #c = [3 + ts[0],0,1,ts[1]] 
            #Theme.Crusor( c )       
               
        glPushMatrix()
        glTranslatef(  3,0 ,0  )
        glColor(0,0,0,1)
        
        if len(self.text) > 0 :
            self.font.Print( self.text )
        
        glPopMatrix()
               
        
    def AddChar(self,char):  
        
        
        
        if char == GLUT_KEY_LEFT:
            self.crusor -= 1
            if self.crusor < 0 :
                self.crusor = 0
                
            return
        
        if char == GLUT_KEY_RIGHT:
            self.crusor += 1
            if self.crusor > len(self.text) :
                self.crusor = len(self.text)
                
            return
        
        
       
      
        if type(char) == int :
            return
      
        
        #new line
        if ord(char) == 13:
          if self.OnEnter :
              self.OnEnter()
              return
        
        #backspace
        if ord(char) == 8:
            if self.crusor > 0:
                self.text = self.text[:self.crusor-1] + self.text[self.crusor:]
                self.crusor -= 1
                
            return
       
        #delete
        if ord(char) == 127:
            if self.crusor < len(self.text):
                self.text = self.text[:self.crusor] + self.text[self.crusor+1:]
                self.selcrusor -=1
            return 
        
        
        if ord(char) == 9:
            self.text = self.text[:self.crusor] + "    " + self.text[self.crusor:]
            self.crusor += 4 
              
            return
        
        #print "add char", ord(char)
        self.text = self.text[:self.crusor] + char + self.text[self.crusor:]
        
        if self.selcrusor == self.crusor :
            self.selcrusor +=1
        
        self.crusor += 1
        
    
    
    def DrawCaret(self):
    
        global Theme,TriD,GUI
        
        selectPos = self.selcrusor
        caretPos  = self.crusor
         
        (x,y,w,h) = self.rec
        
        font_width, font_heigth = self.font.getTextSize( ' ' )
        grid_width, grid_height = ((w-6) / font_width), ((h-6) / font_heigth)

        r, i = 0, 0
        
        if caretPos > selectPos:
            selFrom, selTo =  ( selectPos, caretPos )
        else:
            selFrom, selTo =  ( caretPos, selectPos )
        
        #print selFrom,selTo
        
        scroll = [0,0]
        
    
        lines = self.text.split( chr(13) )
        for line in lines:
            line_len = len( line )
            
            if scroll[1] <= r:
                ly = ( r - scroll[1] ) * font_heigth
#
                # draw selection
                haveSelStart = 0 <= ( selFrom - i ) <= line_len
                haveSelEnd = 0 <= ( selTo - i ) <= line_len
                sx1, sx2 = 0, w
                if haveSelStart:
                    sx1 = max( self.font.getTextSize( line[0:(selFrom - i - scroll[0])]  )[0], 0 )
                if haveSelEnd:
                    sx2 = self.font.getTextSize( line[0:(selTo - i - scroll[0])]  )[0] 
                elif not haveSelStart and ( 0 > ( selTo - i ) or ( selFrom - i ) > line_len ):
                    sx2 = -1

                if sx2 > 0:
                    #sx2 - sx1
                    Theme.SelBox2  ([sx1+3, ly, sx2 - sx1 , font_heigth])
                    #Theme.SelBox2  ([sx1, ly, 1 , font_heigth])
                    #Theme.SelBox2  ([sx2, ly, 1 , font_heigth])

                # draw caret
                if 0 <= ( caretPos -i ) <= line_len: #- i
                    
                    caret = self.font.getTextSize( line[0:caretPos-i]  )[0] #(caretPos - i - scroll[0]) * font_width*2
                   
                    if 0 <= caret <= w:
                        Theme.Crusor([caret+2, ly, 1, font_heigth])

                # draw text
                #if line_len > scroll[0]:
                    #glColor(0,0,0,1)
        
                    #self.font.flatPrint( line )
                    #glTranslate( 0,font_heigth ,0)
                   # renderer.drawText( line[scroll[0]:scroll[0]+grid_width],( x+4, y+ly ), self.fgColor, self.font)

            i += line_len + 1
            r += 1
            if r >= scroll[1] + grid_height:
                break
    
    
    def onMouse(self, pos):
        
        #print self.crusor, self.selcrusor 
        
        self.scroll = [0,0]
        # put hit position in window relative coords
        x = pos[0] - self.wrec[0] - 2
        y = pos[1] - self.wrec[1] - 5
        
        font_width, font_heigth = self.font.getTextSize( ' ')
        
        col = max( math.floor( (float(x) / float(font_width)) ) + self.scroll[0], 0 )
        row = int(max( math.floor( (float(y) / float(font_heigth)) ) + self.scroll[1], 0 ))
        
        
        
        r, c, i = 0, 0, 0
        while r != row:
            try: i = self.text.index( chr(13), i ) + 1
            except: break
            r += 1
        
        
        if int(row) >= len(self.text.split( chr(13) )):
            self.crusor =  len(self.text)
            return
        
        line = self.text.split( chr(13) )[int(row)]
        
        col=0
        while x > col and i < len(self.text):
           
            char = self.text[i]
           
            if char == '\t':
                if ( col + 4*font_width > x ): break
                col += 8*font_width
            elif char == chr(13):
                break
            else:
                col += self.font.getTextSize( char )[0]
            i += 1        
        
        
#        
#        
#        while c < col:
#            if i >= len( self.text) or self.text[i] == '\n':
#                break
#            elif self.text[i] == '\t':
#                if ( c + 4*font_width > col ): break
#                c += 8*font_width
#            else:
#                c += getRenderer().getTextSize( ' ', self.font )[0]
#            i += 1

        self.crusor = min( max( i, 0 ), len( self.text ) )
        
class ScrollerX(Container):   

    def __init__(self, name = "someScroller",  rec = [0,0,300,10] ):
        
        Container.__init__(self,name,rec )
        
        self.Resize = PushButton("",self.StartResize,self.StopResize, [rec[2]/2,0,rec[3]*3,rec[3]]) 
        
        self.Add( self.Resize )
       
       
       
            
    def UpDate(self,m):
        
        global GUI
        
       
        size = self.rec[3]
         
        self.Resize.rec[1] = 0#size
        
#        if self.Resize.rec[0] < 0:
#            self.Resize.rec[0] = 0
#        
#        if self.Resize.rec[0] > self.rec[2]-size:
#            self.Resize.rec[0] = self.rec[2]-size
#        
       
        #    GUI.dragging = None
                   
        
          
               
    def StartResize(self,button):
    
         global GUI
         GUI.dragging = button
         GUI.dragoffset = [ button.wrec[0] - TriD.mouse[0] ,button.wrec[1] - TriD.mouse[1] ]
        
        
    def StopResize(self,button):
        
        global GUI
        GUI.dragging = None

    def Draw(self):
        global Theme,TriD,GUI
        
        TriD.Empty.Bind()
        Theme.BackBox( self.rec )
        