


#     pyTriD
#        simple 3d frame work in python
#        written during the py week 2
#        by Andre Von Houck
#        3/27/2006



import traceback
import time
from OpenGL.GL import *
from OpenGL.GLUT import *
from OpenGL.GLU import *
from Material import *
from Matrix import *
from TriSound import *
#from Model import Model
from Lighting import * 
from TriGUI import *
import sys


# constatns
ESCAPE = '\033'
window = 0


class t2D:
    name = "some t2D"
    text = ""
    rec  = [0,0,0,0]
    



class TriD(t2D):
    
        
    def __init__(self, userDraw , name = "someTriD",  rec = None,fullscreen = False):
        
        self.userDraw = userDraw
        self.name = name
        self.text = name
        self.keyHook = None
        
        if rec == None :
            self.rec = [ 0 , 0 , 1280 ,768 ]
        elif len(rec) == 2 :
            self.rec = [0 , 0 , rec[0], rec[1]]
        elif len(rec) == 4 :
            self.rec = rec
        else:
            self.rec = [ 0 , 0 , 1280 , 768]
        
        self.wrec = self.rec
        
        self.Empty = Empty()
        
        glutInit(sys.argv)
        glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH)
        glutInitWindowSize(self.rec[2], self.rec[3])
        glutInitWindowPosition(self.rec[0], self.rec[1])
        self.window = glutCreateWindow(name)
        
        glutDisplayFunc(self.Draw)
        glutIdleFunc(self.Draw)
        glutReshapeFunc(self.OnResize)
        glutKeyboardFunc(self.OnKey)
        
        glutSpecialFunc(self.OnKey)
        glutKeyboardUpFunc(self.OnKeyUp)
        glutSpecialUpFunc(self.OnKeyUp)
        glutPassiveMotionFunc( self.OnMouseMove   ) 
        glutMotionFunc( self.OnMouseMove   ) 
        glutMouseFunc( self.OnMouseButton )
        
        glutWindowStatusFunc( self.WindowStatusFunc )
              
        
        # GLUT_LEFT_BUTTON, GLUT_MIDDLE_BUTTON, or GLUT_RIGHT_BUTTON
        # SET UP THE KEY HASH
        self.keys = {ESCAPE: False}
        for i in range(000,200):
            self.keys[i] = False
        for i in range(0,255):
            self.keys[chr(i)] = False
        
        self.mouse     = [0,0]
        self.ChangeInMouse = [0,0]
        self.MouseFree = True
        self._oldmouse = [0,0]
        
        
        if fullscreen:
            glutFullScreen()
        self.Setup(self.rec[2], self.rec[3])
     
    
        
    def Go(self):    
        glutMainLoop()
        
    
    def Setup(self,Width, Height):                # We call this right after our OpenGL window is created.
    
        glClearColor(0.0, 0.0, 0.0, 0.0)    # This Will Clear The Background Color To Black
        glClearDepth(1.0)                    # Enables Clearing Of The Depth Buffer
        glDepthFunc(GL_LESS)                # The Type Of Depth Test To Do
        glEnable(GL_DEPTH_TEST)                # Enables Depth Testing
        glShadeModel(GL_SMOOTH)                # Enables Smooth Color Shading
        glEnable(GL_TEXTURE_2D)
   
        
        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()                    # Reset The Projection Matrix
        gluPerspective(45.0, float(Width)/float(Height), 0.1, 1000.0)
        glMatrixMode(GL_MODELVIEW)
        
        self.frame = 0
        self.last = 0
        
        
    
    # The function called when our window is resized (which shouldn't happen if you enable fullscreen, below)
    def OnResize(self,Width, Height):
        if Height == 0:                        # Prevent A Divide By Zero If The Window Is Too Small 
            Height = 1
            
        self.rec[2] =  Width
        self.rec[3] =  Height
           
            
        glViewport(0, 0, Width, Height)        # Reset The Current Viewport And Perspective Transformation
        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()
        gluPerspective(45.0, float(Width)/float(Height), 0.1, 1000.0)
        glMatrixMode(GL_MODELVIEW)
    
    # The main drawing function. 
    def Draw(self):
    
        if self.state == GLUT_HIDDEN or self.state == GLUT_FULLY_COVERED:
            return
        
        self.MouseFree = True # free the mouse form what it was stuck in last frame
        self.ChangeInMouse[0] = self.mouse[0]-self._oldmouse[0]
        self.ChangeInMouse[1] = self.mouse[1]-self._oldmouse[1]
       
        if( self.keys['o'] and self.ChangeInMouse != [0,0]):
            print self.mouse , "from" , self._oldmouse , " is " , self.ChangeInMouse
       
       
        self._oldmouse[0] = self.mouse[0]
        self._oldmouse[1] = self.mouse[1]
        
        self.frame = self.frame + 1
        self.now = time.time()
        if self.now - self.last >= 1:
            self.last = self.now
            #print "FPS: %d" % self.frame
            self.frame = 0
    
        try:
        
            self.userDraw(self)
        except Exception:
            traceback.print_exc(file=sys.stdout)
            sys.exit()
            
            
            
                
        #  since this is double buffered, swap the buffers to display what just got drawn. 
        glutSwapBuffers()
    
    def OnMouseMove(self, x, y ):
        
        
        self.mouse = [x,y]
       
    
    def OnMouseButton(self, button,  state, x,  y) :
        self.mouse = [x,y]
        if state == GLUT_UP:
            self.keys[ button ] = False
        else:
            self.keys[ button ] = True
      
    def MouseInside(self , rec ):
        
        mx,my = self.mouse
        
        if (rec[0] < mx and mx < (rec[2]+rec[0])) and (
                rec[1] < my and my < (rec[3]+rec[1])):
                    
            return True
        else:
            return False
                        
            
        
        
        
    # The function called whenever a key is pressed. Note the use of Python tuples to pass in: (key, x, y)  
    def OnKey(self,*args):
        
        
        
        if self.keyHook != None:
           if self.keyHook(*args) != None :
               self.keys[args[0]] = True
           else:
               pass # key wass eaten up with the gui
                    # we did not get it
           
        else:
            self.keys[args[0]] = True
       
       
       
    def OnKeyUp(self,*args):
        self.keys[args[0]] = False

    def WindowStatusFunc(self, state):
        
        self.state = state
        
        


def DrawBox(r):
    
    
        glColor4f(1, 1, 1 , 1)            # Bluish shade
        glBegin(GL_QUADS)                   # Start drawing a 4 sided polygon
        glTexCoord2f(0.0, 0.0); glVertex3f(r[0], r[1],  0.0)    # Bottom Left Of The Texture and Quad
        glTexCoord2f(1.0, 0.0); glVertex3f(r[2], r[1],  0.0)    # Bottom Right Of The Texture and Quad
        glTexCoord2f(1.0, 1.0); glVertex3f(r[2], r[3],  0.0)    # Top Right Of The Texture and Quad
        glTexCoord2f(0.0, 1.0); glVertex3f(r[0], r[3],  0.0)    # Top Left Of The Texture and Quad
        glEnd()               
       
    

def DrawStar():
    
    
    
    glBegin(GL_QUADS)               
    
    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0,  0)    
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0,  0)    
    glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,  1.0,  0)    
    glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,  1.0,  0)    
    
    glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,  0, -1.0)    
    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0,  0,  1.0)    
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0,  0,  1.0)    
    glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,  0, -1.0)    
    
    glTexCoord2f(1.0, 0.0); glVertex3f( 0, -1.0, -1.0)    
    glTexCoord2f(1.0, 1.0); glVertex3f( 0,  1.0, -1.0)    
    glTexCoord2f(0.0, 1.0); glVertex3f( 0,  1.0,  1.0)    
    glTexCoord2f(0.0, 0.0); glVertex3f( 0, -1.0,  1.0)   
    
    glEnd();               
    
    
    
   
def DrawFlat():
    
    
    
    glBegin(GL_QUADS)               
    
    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0,  0)    
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0,  0)    
    glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,  1.0,  0)    
    glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,  1.0,  0)    
       
    glEnd();               
     
    
    
    

